/*
  Top10, a racing simulator
  Copyright (C) 2000-2004  Johann Deneux
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  
  Authors can be contacted at following electronic addresses:
  Johann Deneux: johann.deneux@it.uu.se
*/

#ifndef CONTROLS_MENU_HH
#define CONTROLS_MENU_HH

#include "UIPanel.hh"
#include "Controls.hh"

namespace top10 {
  namespace ui_interactive {
    class ControlsMenu: public UIPanel::Menu {
    public:
      ControlsMenu(UIPanel*, ActionMapping*);

      void selected();
      void event(SDL_Event);

    private:
      int findActionIdx(Action action) const;
      void updateEntry(int idx, Control ctrl);
      void initEntries();
      void updateEntries(Control);

      static const Action actions[];
      static const int n_entries;
      static const char* action_texts[];

      ActionMapping* digs;
      bool isAssigning;
    };
  };
};
#endif
